diff -uNrp linux-2.6.14.5/fs/relayfs/relay.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/relayfs/relay.c
--- linux-2.6.14.5/fs/relayfs/relay.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/relayfs/relay.c	2006-01-22 13:01:14.000000000 +0100
@@ -18,6 +18,12 @@
 #include "relay.h"
 #include "buffers.h"
 
+#ifdef CONFIG_IPIPE
+LIST_HEAD(relay_wakeup_queue);
+unsigned relay_wakeup_virq;
+spinlock_t relay_wakeup_spinlock = SPIN_LOCK_UNLOCKED;
+#endif /* CONFIG_IPIPE */
+
 /**
  *	relay_buf_empty - boolean, is the channel buffer empty?
  *	@buf: channel buffer
@@ -65,6 +71,15 @@ static int subbuf_start_default_callback
 }
 
 /*
+ * deliver() default callback.  Does nothing.
+ */
+static void deliver_default_callback (struct rchan_buf *buf,
+				      unsigned subbuf_idx,
+				      void *subbuf)
+{
+}
+
+/*
  * buf_mapped() default callback.  Does nothing.
  */
 static void buf_mapped_default_callback(struct rchan_buf *buf,
@@ -80,11 +95,32 @@ static void buf_unmapped_default_callbac
 {
 }
 
+/*
+ * buf_full() default callback.  Does nothing.
+ */
+static void buf_full_default_callback(struct rchan_buf *buf,
+				      unsigned subbuf_idx,
+				      void *subbuf)
+{
+}
+
+/*
+ * buf_unfull() default callback.  Does nothing.
+ */
+static void buf_unfull_default_callback(struct rchan_buf *buf,
+				      unsigned subbuf_idx,
+				      void *subbuf)
+{
+}
+
 /* relay channel default callbacks */
 static struct rchan_callbacks default_channel_callbacks = {
 	.subbuf_start = subbuf_start_default_callback,
+	.deliver = deliver_default_callback,
 	.buf_mapped = buf_mapped_default_callback,
 	.buf_unmapped = buf_unmapped_default_callback,
+	.buf_full = buf_full_default_callback,
+	.buf_unfull = buf_unfull_default_callback,
 };
 
 /**
@@ -101,10 +137,48 @@ static void wakeup_readers(void *private
 	wake_up_interruptible(&buf->read_wait);
 }
 
+#ifdef CONFIG_IPIPE
+
+void relay_wakeup_trampoline (unsigned virq)
+{
+    struct list_head *pos, *npos;
+    unsigned long flags;
+
+    spin_lock_irqsave_hw(&relay_wakeup_spinlock,flags);
+
+    list_for_each_safe(pos,npos,&relay_wakeup_queue) {
+        struct rchan_buf *buf = list_entry(pos,struct rchan_buf,wake_link);
+	list_del(&buf->wake_link);
+	spin_unlock_irqrestore_hw(&relay_wakeup_spinlock,flags);
+	PREPARE_WORK(&buf->wake_readers, wakeup_readers, buf);
+	clear_bit(0,&buf->wake_posted);
+	schedule_delayed_work(&buf->wake_readers, 1);
+	spin_lock_irqsave_hw(&relay_wakeup_spinlock,flags);
+    }
+
+    spin_unlock_irqrestore_hw(&relay_wakeup_spinlock,flags);
+}
+
+#endif /* CONFIG_IPIPE */
+
+/**
+ *	get_next_subbuf - return next sub-buffer within channel buffer
+ *	@buf: channel buffer
+ */
+static inline void *get_next_subbuf(struct rchan_buf *buf)
+{
+	void *next = buf->data + buf->chan->subbuf_size;
+	if (next >= buf->start + buf->chan->subbuf_size * buf->chan->n_subbufs)
+		next = buf->start;
+
+	return next;
+}
+
 /**
  *	__relay_reset - reset a channel buffer
  *	@buf: the channel buffer
  *	@init: 1 if this is a first-time initialization
+ *	@subbufs_count number of subbuffers
  *
  *	See relay_reset for description of effect.
  */
@@ -116,6 +190,10 @@ static inline void __relay_reset(struct 
 		init_waitqueue_head(&buf->read_wait);
 		kref_init(&buf->kref);
 		INIT_WORK(&buf->wake_readers, NULL, NULL);
+#ifdef CONFIG_IPIPE
+		INIT_LIST_HEAD(&buf->wake_link);
+		buf->wake_posted = 0;
+#endif /* CONFIG_IPIPE */
 	} else {
 		cancel_delayed_work(&buf->wake_readers);
 		flush_scheduled_work();
@@ -124,9 +202,11 @@ static inline void __relay_reset(struct 
 	buf->subbufs_produced = 0;
 	buf->subbufs_consumed = 0;
 	buf->bytes_consumed = 0;
+	atomic_set(&buf->full, 0);
 	buf->finalized = 0;
 	buf->data = buf->start;
 	buf->offset = 0;
+	atomic_set(&buf->open_count, 1);
 
 	for (i = 0; i < buf->chan->n_subbufs; i++)
 		buf->padding[i] = 0;
@@ -138,6 +218,8 @@ static inline void __relay_reset(struct 
  *	relay_reset - reset the channel
  *	@chan: the channel
  *
+ *	Returns 0 if successful, negative if not.
+ *
  *	This has the effect of erasing all data from all channel buffers
  *	and restarting the channel in its initial state.  The buffers
  *	are not freed, so any mappings are still in effect.
@@ -195,8 +277,8 @@ static inline void relay_close_buf(struc
 {
 	buf->finalized = 1;
 	buf->chan->cb = &default_channel_callbacks;
-	cancel_delayed_work(&buf->wake_readers);
-	flush_scheduled_work();
+	//cancel_delayed_work(&buf->wake_readers);
+	//flush_scheduled_work();
 	kref_put(&buf->kref, relay_remove_buf);
 }
 
@@ -210,10 +292,16 @@ static inline void setup_callbacks(struc
 
 	if (!cb->subbuf_start)
 		cb->subbuf_start = subbuf_start_default_callback;
+	if (!cb->deliver)
+		cb->deliver = deliver_default_callback;
 	if (!cb->buf_mapped)
 		cb->buf_mapped = buf_mapped_default_callback;
 	if (!cb->buf_unmapped)
 		cb->buf_unmapped = buf_unmapped_default_callback;
+	if (!cb->buf_full)
+		cb->buf_full = buf_full_default_callback;
+	if (!cb->buf_unfull)
+		cb->buf_unfull = buf_unfull_default_callback;
 	chan->cb = cb;
 }
 
@@ -223,7 +311,11 @@ static inline void setup_callbacks(struc
  *	@parent: dentry of parent directory, NULL for root directory
  *	@subbuf_size: size of sub-buffers
  *	@n_subbufs: number of sub-buffers
+ *	@overwrite: overwrite buffer when full?
  *	@cb: client callback functions
+ *	@fops: client file operations (override relayfs). NULL for default.
+ *	@client_data: client specific data
+ *	@free_client_data_cb: callback function to free the client data.
  *
  *	Returns channel pointer if successful, NULL otherwise.
  *
@@ -231,12 +323,18 @@ static inline void setup_callbacks(struc
  *	attributes specified.  The created channel buffer files
  *	will be named base_filename0...base_filenameN-1.  File
  *	permissions will be S_IRUSR.
+ *	relay_open increments the usage count of the client_module.
  */
 struct rchan *relay_open(const char *base_filename,
 			 struct dentry *parent,
 			 size_t subbuf_size,
 			 size_t n_subbufs,
-			 struct rchan_callbacks *cb)
+			 int overwrite,
+			 struct module *client_module,
+			 struct rchan_callbacks *cb,
+			 struct file_operations *fops,
+			 void *client_data,
+			 void (*free_client_data_cb)(void*))
 {
 	unsigned int i;
 	struct rchan *chan;
@@ -253,10 +351,19 @@ struct rchan *relay_open(const char *bas
 		return NULL;
 
 	chan->version = RELAYFS_CHANNEL_VERSION;
+	chan->overwrite = overwrite;
 	chan->n_subbufs = n_subbufs;
 	chan->subbuf_size = subbuf_size;
 	chan->alloc_size = FIX_SIZE(subbuf_size * n_subbufs);
+	chan->client_module = client_module;
+	if(!try_module_get(client_module)) {
+		printk(KERN_ERR "RelayFS : cannot increment client module refcount\n");
+		return NULL;
+	}
+	chan->client_data = client_data;
+	chan->free_client_data_cb = free_client_data_cb;
 	setup_callbacks(chan, cb);
+	setup_fileops(chan, fops);
 	kref_init(&chan->kref);
 
 	tmpname = kmalloc(NAME_MAX + 1, GFP_KERNEL);
@@ -264,7 +371,7 @@ struct rchan *relay_open(const char *bas
 		goto free_chan;
 
 	for_each_online_cpu(i) {
-		sprintf(tmpname, "%s%d", base_filename, i);
+		sprintf(tmpname, "%s_%d", base_filename, i);
 		chan->buf[i] = relay_open_buf(chan, tmpname, parent);
 		chan->buf[i]->cpu = i;
 		if (!chan->buf[i])
@@ -311,8 +418,24 @@ size_t relay_switch_subbuf(struct rchan_
 		buf->padding[old_subbuf] = buf->prev_padding;
 		buf->subbufs_produced++;
 		if (waitqueue_active(&buf->read_wait)) {
-			PREPARE_WORK(&buf->wake_readers, wakeup_readers, buf);
-			schedule_delayed_work(&buf->wake_readers, 1);
+#ifdef CONFIG_IPIPE
+		  if (ipipe_current_domain != ipipe_root_domain) {
+		      if (!test_and_set_bit(0,&buf->wake_posted)) {
+			unsigned long flags;
+			spin_lock_irqsave_hw(&relay_wakeup_spinlock,flags);
+			list_add_tail(&buf->wake_link,&relay_wakeup_queue);
+			spin_unlock_irqrestore_hw(&relay_wakeup_spinlock,flags);
+			ipipe_propagate_irq(relay_wakeup_virq);
+		      }
+		    }
+		  else {
+		      PREPARE_WORK(&buf->wake_readers, wakeup_readers, buf);
+		      schedule_delayed_work(&buf->wake_readers, 1);	      
+		    }
+#else /* !CONFIG_IPIPE */
+		  PREPARE_WORK(&buf->wake_readers, wakeup_readers, buf);
+		  schedule_delayed_work(&buf->wake_readers, 1);
+#endif /* CONFIG_IPIPE */
 		}
 	}
 
@@ -333,7 +456,10 @@ size_t relay_switch_subbuf(struct rchan_
 	return length;
 
 toobig:
-	printk(KERN_WARNING "relayfs: event too large (%Zd)\n", length);
+	/* Fixme : we cannot, never ever, call a printk from LTT schedule and
+	 * wakeup instrumentation! A deadlock would occur. We must find another
+	 * way to print debug messages. */
+	//printk(KERN_WARNING "relayfs: event too large (%Zd)\n", length);
 	WARN_ON(1);
 	return 0;
 }
@@ -377,6 +503,9 @@ void relay_subbufs_consumed(struct rchan
 void relay_destroy_channel(struct kref *kref)
 {
 	struct rchan *chan = container_of(kref, struct rchan, kref);
+	module_put(chan->client_module);
+	if(chan->free_client_data_cb)
+		chan->free_client_data_cb(chan->client_data);
 	kfree(chan);
 }
 
diff -uNrp linux-2.6.14.5/fs/select.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/select.c
--- linux-2.6.14.5/fs/select.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/select.c	2006-01-22 13:01:14.000000000 +0100
@@ -14,6 +14,7 @@
  *     of fds to overcome nfds < 16390 descriptors limit (Tigran Aivazian).
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/syscalls.h>
 #include <linux/module.h>
 #include <linux/slab.h>
@@ -228,6 +229,8 @@ int do_select(int n, fd_set_bits *fds, l
 				file = fget(i);
 				if (file) {
 					f_op = file->f_op;
+					trace_fs_select(i, /* The fd */
+													__timeout);
 					mask = DEFAULT_POLLMASK;
 					if (f_op && f_op->poll)
 						mask = (*f_op->poll)(file, retval ? NULL : wait);
@@ -420,6 +423,7 @@ static void do_pollfd(unsigned int num, 
 			struct file * file = fget(fd);
 			mask = POLLNVAL;
 			if (file != NULL) {
+				trace_fs_poll(fd);
 				mask = DEFAULT_POLLMASK;
 				if (file->f_op && file->f_op->poll)
 					mask = file->f_op->poll(file, *pwait);
diff -uNrp linux-2.6.14.5/include/asm-alpha/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-alpha/ltt.h
--- linux-2.6.14.5/include/asm-alpha/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-alpha/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,15 @@
+#ifndef _ASM_ALPHA_LTT_H
+#define _ASM_ALPHA_LTT_H
+/*
+ * linux/include/asm-alpha/ltt.h
+ *
+ * Copyright (C) 2005 - Mathiey Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
+ * Copyright (C) 2002 - Karim Yaghmour (karim@opersys.com)
+ *
+ * alpha architecture specific definitions for ltt
+ */
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-arm/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-arm/ltt.h
--- linux-2.6.14.5/include/asm-arm/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-arm/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,14 @@
+/*
+ * linux/include/asm-arm/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * ARM definitions for tracing system
+ */
+
+#ifndef _ASM_ARM_LTT_H
+#define _ASM_ARM_LTT_H
+
+#include <asm-generic/ltt.h>
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-arm26/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-arm26/ltt.h
--- linux-2.6.14.5/include/asm-arm26/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-arm26/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_ARM26_LTT_H
+#define _ASM_ARM26_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-cris/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-cris/ltt.h
--- linux-2.6.14.5/include/asm-cris/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-cris/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_CRIS_LTT_H
+#define _ASM_CRIS_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-frv/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-frv/ltt.h
--- linux-2.6.14.5/include/asm-frv/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-frv/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_FRV_LTT_H
+#define _ASM_FRV_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-generic/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-generic/ltt.h
--- linux-2.6.14.5/include/asm-generic/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-generic/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,14 @@
+#ifndef _ASM_GENERIC_LTT_H
+#define _ASM_GENERIC_LTT_H
+/*
+ * linux/include/asm-generic/ltt.h
+ *
+ * Copyright (C) 2005 - Mathiey Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
+ * Copyright (C) 2002 - Karim Yaghmour (karim@opersys.com)
+ *
+ * Architecture dependent definitions for ltt
+ * Architecture without TSC
+ */
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-h8300/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-h8300/ltt.h
--- linux-2.6.14.5/include/asm-h8300/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-h8300/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_H8300_LTT_H
+#define _ASM_H8300_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-i386/apic.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/apic.h
--- linux-2.6.14.5/include/asm-i386/apic.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/apic.h	2006-01-22 13:01:14.000000000 +0100
@@ -82,7 +82,13 @@ int get_physical_broadcast(void);
 # define apic_write_around(x,y) apic_write_atomic((x),(y))
 #endif
 
+#ifdef CONFIG_IPIPE
+#define ack_APIC_irq() do { } while(0)
+static inline void __ack_APIC_irq(void)
+#else /* !CONFIG_IPIPE */
+#define __ack_APIC_irq() ack_APIC_irq()
 static inline void ack_APIC_irq(void)
+#endif /* CONFIG_IPIPE */
 {
 	/*
 	 * ack_APIC_irq() actually gets compiled as a single instruction:
@@ -117,7 +123,7 @@ extern int reserve_lapic_nmi(void);
 extern void release_lapic_nmi(void);
 extern void disable_timer_nmi_watchdog(void);
 extern void enable_timer_nmi_watchdog(void);
-extern void nmi_watchdog_tick (struct pt_regs * regs);
+extern void (*nmi_watchdog_tick) (struct pt_regs * regs);
 extern int APIC_init_uniprocessor (void);
 extern void disable_APIC_timer(void);
 extern void enable_APIC_timer(void);
diff -uNrp linux-2.6.14.5/include/asm-i386/io_apic.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/io_apic.h
--- linux-2.6.14.5/include/asm-i386/io_apic.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/io_apic.h	2006-01-22 13:01:14.000000000 +0100
@@ -16,8 +16,14 @@
 #ifdef CONFIG_PCI_MSI
 static inline int use_pci_vector(void)	{return 1;}
 static inline void disable_edge_ioapic_vector(unsigned int vector) { }
+#ifdef CONFIG_IPIPE
+#ifndef CONFIG_IRQBALANCE
+static inline void end_edge_ioapic_vector (unsigned int vector) { }
+#endif /* !CONFIG_IRQBALANCE */
+#else /* !CONFIG_IPIPE */
 static inline void mask_and_ack_level_ioapic_vector(unsigned int vector) { }
 static inline void end_edge_ioapic_vector (unsigned int vector) { }
+#endif /* CONFIG_IPIPE */
 #define startup_level_ioapic	startup_level_ioapic_vector
 #define shutdown_level_ioapic	mask_IO_APIC_vector
 #define enable_level_ioapic	unmask_IO_APIC_vector
@@ -35,8 +41,14 @@ static inline void end_edge_ioapic_vecto
 #else
 static inline int use_pci_vector(void)	{return 0;}
 static inline void disable_edge_ioapic_irq(unsigned int irq) { }
+#ifdef CONFIG_IPIPE
+#ifndef CONFIG_IRQBALANCE
+static inline void end_edge_ioapic_irq (unsigned int irq) { }
+#endif /* !CONFIG_IRQBALANCE */
+#else /* CONFIG_IPIPE */
 static inline void mask_and_ack_level_ioapic_irq(unsigned int irq) { }
 static inline void end_edge_ioapic_irq (unsigned int irq) { }
+#endif /* CONFIG_IPIPE */
 #define startup_level_ioapic	startup_level_ioapic_irq
 #define shutdown_level_ioapic	mask_IO_APIC_irq
 #define enable_level_ioapic	unmask_IO_APIC_irq
diff -uNrp linux-2.6.14.5/include/asm-i386/ipipe.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/ipipe.h
--- linux-2.6.14.5/include/asm-i386/ipipe.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/ipipe.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,207 @@
+/*   -*- linux-c -*-
+ *   include/asm-i386/ipipe.h
+ *
+ *   Copyright (C) 2002-2005 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __I386_IPIPE_H
+#define __I386_IPIPE_H
+
+#include <linux/config.h>
+
+#ifdef CONFIG_IPIPE
+
+#include <linux/threads.h>
+#include <irq_vectors.h>
+
+#define IPIPE_ARCH_STRING	"1.1-00"
+#define IPIPE_MAJOR_NUMBER	1
+#define IPIPE_MINOR_NUMBER	1
+#define IPIPE_PATCH_NUMBER	0
+
+#ifdef CONFIG_X86_LOCAL_APIC
+/* We want to cover the whole IRQ space when the APIC is enabled. */
+#ifdef CONFIG_PCI_MSI
+#define IPIPE_NR_XIRQS NR_IRQS
+#else	/* CONFIG_PCI_MSI */
+#define IPIPE_NR_XIRQS   224
+#endif	/* CONFIG_PCI_MSI */
+/* If the APIC is enabled, then we expose four service vectors in the
+   APIC space which are freely available to domains. */
+#define IPIPE_SERVICE_VECTOR0	0xf5
+#define IPIPE_SERVICE_IPI0	(IPIPE_SERVICE_VECTOR0 - FIRST_EXTERNAL_VECTOR)
+#define IPIPE_SERVICE_VECTOR1	0xf6
+#define IPIPE_SERVICE_IPI1	(IPIPE_SERVICE_VECTOR1 - FIRST_EXTERNAL_VECTOR)
+#define IPIPE_SERVICE_VECTOR2	0xf7
+#define IPIPE_SERVICE_IPI2	(IPIPE_SERVICE_VECTOR2 - FIRST_EXTERNAL_VECTOR)
+#define IPIPE_SERVICE_VECTOR3	0xf8
+#define IPIPE_SERVICE_IPI3	(IPIPE_SERVICE_VECTOR3 - FIRST_EXTERNAL_VECTOR)
+#else	/* !CONFIG_X86_LOCAL_APIC */
+#define IPIPE_NR_XIRQS		NR_IRQS
+#endif	/* CONFIG_X86_LOCAL_APIC */
+
+#define IPIPE_IRQ_ISHIFT  	5	/* 2^5 for 32bits arch. */
+#define NR_XIRQS		IPIPE_NR_XIRQS
+
+#define ex_do_divide_error		0
+#define ex_do_debug			1
+/* NMI not pipelined. */
+#define ex_do_int3			3
+#define ex_do_overflow			4
+#define ex_do_bounds			5
+#define ex_do_invalid_op		6
+#define ex_device_not_available		7
+/* Double fault not pipelined. */
+#define ex_do_coprocessor_segment_overrun 9
+#define ex_do_invalid_TSS		10
+#define ex_do_segment_not_present	11
+#define ex_do_stack_segment		12
+#define ex_do_general_protection	13
+#define ex_do_page_fault		14
+#define ex_do_spurious_interrupt_bug	15
+#define ex_do_coprocessor_error		16
+#define ex_do_alignment_check		17
+#define ex_machine_check_vector		18
+#define ex_do_simd_coprocessor_error	19
+#define ex_do_iret_error		32
+
+#ifndef __ASSEMBLY__
+
+#include <linux/cpumask.h>
+#include <linux/list.h>
+#include <linux/threads.h>
+#include <asm/ptrace.h>
+
+#ifdef CONFIG_SMP
+
+#include <asm/fixmap.h>
+#include <asm/mpspec.h>
+#include <mach_apicdef.h>
+#include <linux/thread_info.h>
+
+#define IPIPE_CRITICAL_VECTOR  0xf9	/* Used by ipipe_critical_enter/exit() */
+#define IPIPE_CRITICAL_IPI     (IPIPE_CRITICAL_VECTOR - FIRST_EXTERNAL_VECTOR)
+
+static inline int ipipe_processor_id(void)
+{
+	extern int (*__ipipe_logical_cpuid)(void);
+	return __ipipe_logical_cpuid();
+}
+
+extern u8 __ipipe_apicid_2_cpu[];
+
+#define ipipe_note_apicid(apicid,cpu)  \
+do {	\
+	__ipipe_apicid_2_cpu[apicid] = cpu; \
+} while(0)
+
+#else	/* !CONFIG_SMP */
+
+#define ipipe_note_apicid(apicid,cpu)  do { } while(0)
+#define ipipe_processor_id()    0
+
+#endif	/* CONFIG_SMP */
+
+#define prepare_arch_switch(next) \
+do { \
+	__ipipe_dispatch_event(IPIPE_EVENT_SCHEDULE,next);	\
+	local_irq_disable_hw();					\
+} while(0)
+
+#define task_hijacked(p)	\
+  ({ int x = ipipe_current_domain != ipipe_root_domain; \
+     __clear_bit(IPIPE_SYNC_FLAG,&ipipe_root_domain->cpudata[task_cpu(p)].status); \
+     local_irq_enable_hw(); x; })
+
+/* IDT fault vectors */
+#define IPIPE_NR_FAULTS		33 /* 32 from IDT + iret_error */
+/* Pseudo-vectors used for kernel events */
+#define IPIPE_FIRST_EVENT	IPIPE_NR_FAULTS
+#define IPIPE_EVENT_SYSCALL	(IPIPE_FIRST_EVENT)
+#define IPIPE_EVENT_SCHEDULE	(IPIPE_FIRST_EVENT + 1)
+#define IPIPE_EVENT_SIGWAKE	(IPIPE_FIRST_EVENT + 2)
+#define IPIPE_EVENT_SETSCHED	(IPIPE_FIRST_EVENT + 3)
+#define IPIPE_EVENT_EXIT	(IPIPE_FIRST_EVENT + 4)
+#define IPIPE_LAST_EVENT	IPIPE_EVENT_EXIT
+#define IPIPE_NR_EVENTS		(IPIPE_LAST_EVENT + 1)
+
+struct ipipe_domain;
+
+struct ipipe_sysinfo {
+
+	int ncpus;		/* Number of CPUs on board */
+	u64 cpufreq;		/* CPU frequency (in Hz) */
+
+	/* Arch-dependent block */
+
+	struct {
+		unsigned tmirq;	/* Timer tick IRQ */
+		u64 tmfreq;	/* Timer frequency */
+	} archdep;
+};
+
+#define ipipe_read_tsc(t)  __asm__ __volatile__("rdtsc" : "=A" (t))
+#define ipipe_cpu_freq() ({ unsigned long long __freq = cpu_has_tsc?(1000LL * cpu_khz):CLOCK_TICK_RATE; __freq; })
+
+#define ipipe_tsc2ns(t) \
+({ \
+	unsigned long long delta = (t)*1000; \
+	do_div(delta, cpu_khz/1000+1); \
+	(unsigned long)delta; \
+})
+
+#define ipipe_tsc2us(t) \
+({ \
+    unsigned long long delta = (t); \
+    do_div(delta, cpu_khz/1000+1); \
+    (unsigned long)delta; \
+})
+
+/* Private interface -- Internal use only */
+
+#define __ipipe_check_platform() do { } while(0)
+
+#define __ipipe_init_platform() do { } while(0)
+
+void __ipipe_enable_pipeline(void);
+
+void fastcall __ipipe_sync_stage(unsigned long syncmask);
+
+int __ipipe_ack_system_irq(unsigned irq);
+
+int __ipipe_handle_irq(struct pt_regs regs);
+
+void __ipipe_do_critical_sync(unsigned irq);
+
+extern struct pt_regs __ipipe_tick_regs[];
+
+extern int __ipipe_tick_irq;
+
+#endif /* __ASSEMBLY__ */
+
+#else /* !CONFIG_IPIPE */
+
+#define task_hijacked(p)	0
+
+#define NR_XIRQS NR_IRQS
+
+#define ipipe_note_apicid(apicid,cpu)  do { } while(0)
+
+#endif /* CONFIG_IPIPE */
+
+#endif	/* !__I386_IPIPE_H */
diff -uNrp linux-2.6.14.5/include/asm-i386/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/ltt.h
--- linux-2.6.14.5/include/asm-i386/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,117 @@
+#ifndef _ASM_I386_LTT_H
+#define _ASM_I386_LTT_H
+/*
+ * linux/include/asm-i386/ltt.h
+ *
+ * Copyright (C) 2005 - Mathiey Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
+ * Copyright (C) 2002 - Karim Yaghmour (karim@opersys.com)
+ *
+ * i386 time and TSC definitions for ltt
+ */
+
+#include <linux/time.h>
+
+#include <asm/timex.h>
+#include <asm/processor.h>
+
+#define LTT_ARCH_TYPE LTT_ARCH_TYPE_I386
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_NONE
+
+#define LTT_TSC_READY
+
+/**
+ *	calc_time_delta - utility function for time delta calculation
+ *	@now: current time
+ *	@start: start time
+ *
+ *	Returns the time delta produced by subtracting start time from now.
+ */
+static inline u64
+calc_time_delta(struct timeval *now,
+		struct timeval *start)
+{
+	return (now->tv_sec - start->tv_sec) * USEC_PER_SEC
+		+ (now->tv_usec - start->tv_usec);
+}
+
+/**
+ *	get_time_delta - utility function for getting time delta
+ *	@now: pointer to a timeval struct that may be given current time
+ *	@start: the previous time
+ *
+ *	Returns either the TSC if TSCs are being used, or the time and the
+ *	time difference between the current time and the buffer start time
+ *	if TSCs are not being used.
+ *
+ *	We use the same validation as get_cycles() from asm-i386/timex.h : we cannot
+ *	rely on get_cycles() returning 0, because it is a possible value of the TSC.
+ */
+static inline u64
+get_time_delta(struct timeval *now, struct timeval *start)
+{
+	u64 time_delta;
+
+#ifndef CONFIG_X86_TSC
+	if (!cpu_has_tsc) {
+		do_gettimeofday(now);
+		time_delta = calc_time_delta(now, start);
+		return time_delta;
+	}
+#endif
+
+#if defined(CONFIG_X86_GENERIC) || defined(CONFIG_X86_TSC)
+	time_delta = (u64)get_cycles();
+#else
+	do_gettimeofday(now);
+	time_delta = calc_time_delta(now, start);
+#endif
+	return time_delta;
+}
+
+/**
+ *	get_timestamp - utility function for getting a time and TSC pair
+ *	@now: current time
+ *	@tsc: the TSC associated with now
+ *
+ *	Sets the value pointed to by now to the current time and the value
+ *	pointed to by tsc to the tsc associated with that time, if the
+ *	platform supports TSC.
+ */
+static inline void
+get_timestamp(struct timeval *now,
+	      u64 *tsc)
+{
+	do_gettimeofday(now);
+	
+	*tsc = (u64)get_cycles();
+}
+
+/**
+ *	get_time_or_tsc - utility function for getting a time or a TSC
+ *	@now: current time
+ *	@tsc: current TSC
+ *
+ *	Sets the value pointed to by now to the current time or the value
+ *	pointed to by tsc to the current tsc, depending on whether we're
+ *	using TSCs or not.
+ */
+static inline void
+get_time_or_tsc(struct timeval *now,
+		u64 *tsc)
+{
+#ifndef CONFIG_X86_TSC
+	if (!cpu_has_tsc) {
+		do_gettimeofday(now);
+		return;
+	}
+#endif
+
+#if defined(CONFIG_X86_GENERIC) || defined(CONFIG_X86_TSC)
+	*tsc = (u64)get_cycles();
+#else
+	do_gettimeofday(now);
+#endif
+}
+
+#endif //_ASM_I386_LTT_H
diff -uNrp linux-2.6.14.5/include/asm-i386/mach-default/do_timer.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mach-default/do_timer.h
--- linux-2.6.14.5/include/asm-i386/mach-default/do_timer.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mach-default/do_timer.h	2006-01-22 13:01:14.000000000 +0100
@@ -50,14 +50,15 @@ static inline void do_timer_interrupt_ho
 static inline int do_timer_overflow(int count)
 {
 	int i;
+	unsigned long flags;
 
-	spin_lock(&i8259A_lock);
+	spin_lock_irqsave_hw_cond(&i8259A_lock, flags);
 	/*
 	 * This is tricky when I/O APICs are used;
 	 * see do_timer_interrupt().
 	 */
 	i = inb(0x20);
-	spin_unlock(&i8259A_lock);
+	spin_unlock_irqrestore_hw_cond(&i8259A_lock, flags);
 	
 	/* assumption about timer being IRQ0 */
 	if (i & 0x01) {
diff -uNrp linux-2.6.14.5/include/asm-i386/mach-visws/do_timer.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mach-visws/do_timer.h
--- linux-2.6.14.5/include/asm-i386/mach-visws/do_timer.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mach-visws/do_timer.h	2006-01-22 13:01:14.000000000 +0100
@@ -29,14 +29,15 @@ static inline void do_timer_interrupt_ho
 static inline int do_timer_overflow(int count)
 {
 	int i;
+	unsigned long flags;
 
-	spin_lock(&i8259A_lock);
+	spin_lock_irqsave_hw_cond(&i8259A_lock, flags);
 	/*
 	 * This is tricky when I/O APICs are used;
 	 * see do_timer_interrupt().
 	 */
 	i = inb(0x20);
-	spin_unlock(&i8259A_lock);
+	spin_unlock_irqrestore_hw_cond(&i8259A_lock, flags);
 	
 	/* assumption about timer being IRQ0 */
 	if (i & 0x01) {
diff -uNrp linux-2.6.14.5/include/asm-i386/mmu_context.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mmu_context.h
--- linux-2.6.14.5/include/asm-i386/mmu_context.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/mmu_context.h	2006-01-22 13:01:14.000000000 +0100
@@ -67,6 +67,11 @@ static inline void switch_mm(struct mm_s
 	asm("movl %0,%%fs ; movl %0,%%gs": :"r" (0))
 
 #define activate_mm(prev, next) \
-	switch_mm((prev),(next),NULL)
+do { \
+	unsigned long flags; \
+	local_irq_save_hw_cond(flags); \
+	switch_mm((prev),(next),NULL);		   \
+	local_irq_restore_hw_cond(flags);	   \
+} while(0)
 
 #endif
diff -uNrp linux-2.6.14.5/include/asm-i386/nmi.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/nmi.h
--- linux-2.6.14.5/include/asm-i386/nmi.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/nmi.h	2006-01-22 13:01:14.000000000 +0100
@@ -25,4 +25,6 @@ void set_nmi_callback(nmi_callback_t cal
  */
 void unset_nmi_callback(void);
  
+void die_nmi(struct pt_regs *, const char *msg);
+
 #endif /* ASM_NMI_H */
diff -uNrp linux-2.6.14.5/include/asm-i386/pgalloc.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/pgalloc.h
--- linux-2.6.14.5/include/asm-i386/pgalloc.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/pgalloc.h	2006-01-22 13:01:14.000000000 +0100
@@ -47,4 +47,27 @@ static inline void pte_free(struct page 
 
 #define check_pgt_cache()	do { } while (0)
 
+static inline void set_pgdir(unsigned long address, pgd_t entry)
+{
+#ifdef CONFIG_IPIPE
+	struct task_struct * p;
+	struct page *page;
+	pgd_t *pgd;
+
+	read_lock(&tasklist_lock);
+
+	for_each_process(p) {
+		if(p->mm) 
+		    *pgd_offset(p->mm,address) = entry;
+	}
+
+	read_unlock(&tasklist_lock);
+
+	for (page = pgd_list; page; page = (struct page *)page->index) {
+		pgd = (pgd_t *)page_address(page);
+		pgd[address >> PGDIR_SHIFT] = entry;
+	}
+#endif /* CONFIG_IPIPE */
+}
+
 #endif /* _I386_PGALLOC_H */
diff -uNrp linux-2.6.14.5/include/asm-i386/spinlock.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/spinlock.h
--- linux-2.6.14.5/include/asm-i386/spinlock.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/spinlock.h	2006-01-22 13:01:14.000000000 +0100
@@ -32,6 +32,9 @@
 	"jmp 1b\n" \
 	"3:\n\t"
 
+#ifdef CONFIG_IPIPE
+#define __raw_spin_lock_string_flags __raw_spin_lock_string
+#else /* !CONFIG_IPIPE */
 #define __raw_spin_lock_string_flags \
 	"\n1:\t" \
 	"lock ; decb %0\n\t" \
@@ -47,6 +50,7 @@
 	"cli\n\t" \
 	"jmp 1b\n" \
 	"4:\n\t"
+#endif /* CONFIG_IPIPE */
 
 static inline void __raw_spin_lock(raw_spinlock_t *lock)
 {
